﻿;DNA GADGET CONTROL IO SYSTEM


Procedure __SAVE_DNA(_ai42_directory.s)
  
  Define _io_ok.l=0
  Define _gad.l=1
  Define _flip_flop.b=0
  
  _io_ok.l=OpenFile(#PB_Any,_ai42_directory.s+"ai42.ai42")
  
  
  If IsFile(_io_ok.l)
    
    While IsGadget(_gad.l)
   
      WriteStringN(_io_ok.l,GetGadgetText(_gad.l))
      WriteStringN(_io_ok.l,"")
  
      _gad+2
    
    Wend
    CloseFile(_io_ok.l)
    
    __ERROR_AI42(#_INFO_SAVE_DNA_DONE,_ai42_directory.s+"ai42.ai42")
    
  Else
    
    __ERROR_AI42(#_ERROR_SAVE_RGB_DNA,_ai42_directory.s+"ai42.ai42")
    
  EndIf
  
EndProcedure

Procedure __SAVE_DNA_AS( _object_ai_name.s)
  
  Define _io_ok.l=0
  Define _gad.l=1
  Define _is.s=_object_ai_name.s+_object_extension.s
  
  _a42_dna_file$=SaveFileRequester("Save DNA", _is.s,"AIFILE (*ai42)|*.ai42",0)
  _io_ok.l=OpenFile(#PB_Any,_a42_dna_file$)
  If _io_ok.l<>0
    
    While IsGadget(_gad.l)
      
      If FindString(GetGadgetText(_gad.l),"AI42_KEYWORD",1)=0 And FindString(GetGadgetText(_gad.l),"AI42_VALUE",1)=0 
        WriteStringN(_io_ok.l,GetGadgetText(_gad.l))
      EndIf
      _gad+1
    Wend
    CloseFile(_io_ok.l)
    __ERROR_AI42(#_INFO_SAVE_DNA_DONE,_is.s)
  Else
    __ERROR_AI42(#_ERROR_SAVE_RGB_DNA,_is.s)
  EndIf
  
EndProcedure






Procedure  __PARSE_FONT(_io_ok.l,_rgb_dna$)
  Define _my_gad.l=1
  Define _key$=""
  Define _key1$=""
  Define _col_set.l=0
  Define _is_emty_string.b=0  ;fix the problem With older /earlier version  ai42 files, which used "emty strings" To Define the size of the gadget field, so we can use allways the last version of ai42 file
  
  ;now some basic settings we have to do:
  

  While Not Eof(_io_ok.l) And _is_emty_string.b<1
    
    _key$=ReadString(_io_ok.l)
    _key1$=ReadString(_io_ok.l)
    
    If _key$="" And _key1$=""
      _is_emty_string.b=1
      
      Else
    
    If IsGadget(_my_gad.l)
      SetGadgetText(_my_gad.l,_key$)
      _my_gad.l+1
    EndIf
    
      If IsGadget(_my_gad.l)
       SetGadgetText(_my_gad.l,_key1$)
       _my_gad.l+1
     EndIf
    
    
  EndIf
  
   
  Wend
  
  ;__ERROR_AI42(#_INFO_LOAD_DNA_DONE,_rgb_dna$)
  _a42_dna_file$=_rgb_dna$
  
EndProcedure




Procedure  __PARSE_DNA(_io_ok.l,_rgb_dna$)
  Define _my_gad.l=1
  Define _key$=""
  Define _key1$=""
  Define _col_set.l=0
  Define _is_emty_string.b=0  ;fix the problem With older /earlier version  ai42 files, which used "emty strings" To Define the size of the gadget field, so we can use allways the last version of ai42 file
  
  ;now some basic settings we have to do:
 
  
  While Not Eof(_io_ok.l) And _is_emty_string.b<1
    
    _key$=ReadString(_io_ok.l)
    _key1$=ReadString(_io_ok.l)
    
    If _key$="" And _key1$=""
      _is_emty_string.b=1
      
      Else
    
    If IsGadget(_my_gad.l)
      SetGadgetText(_my_gad.l,_key$)
      _my_gad.l+1
    EndIf
    
      If IsGadget(_my_gad.l)
       SetGadgetText(_my_gad.l,_key1$)
       _my_gad.l+1
     EndIf
    
    
  EndIf
  
   
  Wend
  
  ;__ERROR_AI42(#_INFO_LOAD_DNA_DONE,_rgb_dna$)
  _a42_dna_file$=_rgb_dna$
  
EndProcedure



Procedure __GET_DNA(_rgb_dna$)
  
  Define _io_ok.l
  
  _io_ok.l=ReadFile(#PB_Any,_rgb_dna$)
  
  If _io_ok.l<>0
    
    __PARSE_DNA(_io_ok.l,_rgb_dna$)
    
    CloseFile(_io_ok.l)
    
     __ERROR_AI42(#_INFO_LOAD_DNA_DONE,_rgb_dna$)
  EndIf
  
EndProcedure
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 116
; FirstLine = 100
; Folding = -
; EnableXP
; EnableOnError
; CPU = 1
; SubSystem = DX9
; DisableDebugger
; HideErrorLog