﻿Procedure __CREATE_LOG()
Define _ok.l=0

_ok.l=OpenFile(#PB_Any,GetCurrentDirectory()+"ai42_log.txt")


If _ok.l<>0
  
  FileSeek(_ok.l,Lof(_ok.l))
WriteStringN(_ok.l,"***************************")
WriteStringN(_ok.l,"HOME: "+_ai42_directory.s)
WriteStringN(_ok.l,"INIFILE: "+_ai42_script$)
WriteStringN(_ok.l,"WINDOW_ID: "+Str( _window_id.l))
WriteStringN(_ok.l,"WINDOWTITLE: "+_window_name$)
WriteStringN(_ok.l,"AI42 PRIORITY: "+Str(_ai42_priority))  ;default for multitasking
WriteStringN(_ok.l,"LOG CREATED: "+FormatDate("%yyyy/%mm/%dd TIME %hh:%ii:%ss",Date()))

CloseFile(_ok.l)
EndIf

EndProcedure


Procedure __A42_CONTROLLER(_key$,_val$)

Select _key$

Case "window_w"
_window_size_x=DesktopWidth(0)*ValF(_val$)


Case "window_h"
_window_size_y=DesktopHeight(0)*ValF(_val$)

Case "window_name"
_window_name$=_val$

Case "ai42_source"
_ai42_source$=_val$

Case "ai42_priority"
_ai42_priority=255-Val(_val$)

If _ai42_priority<0
_ai42_priority=0
EndIf

Case "ai42_width"
_ai42_width.f=ValF(_val$)
Case "ai42_height"
;_ai42_height.f=ValF(_val$)

Case "ai42_span"
_ai42_span.f=ValF(_val$)

Case "ai42_width"
_ai42_width.f=_window_size_x*ValF(_val$)

Case "ai42_menu"
_ai42_menu_path$=_val$

Case "ai_max_dna_gadgets"
  _max_gadgets.l=Val(_val$)
  
Case "sound_type"
  

EndSelect


EndProcedure



Procedure __AI42PARSER(_all$)

Define _ok.l=0
Define _key$
Define _val$

_ok.l=ReadFile(#PB_Any,_all$)

If _ok.l=0
__ERROR_AI42(#_ERROR_AI42_START,"")
EndIf

;all working:
While Not Eof(_ok.l)

_key$=ReadString(_ok.l)
_val$=ReadString(_ok.l)

__A42_CONTROLLER(_key$,_val$)


Wend

CloseFile(_ok.l)





EndProcedure
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 10
; FirstLine = 6
; Folding = -
; EnableXP
; EnableOnError
; CPU = 1
; SubSystem = DX9
; DisableDebugger
; HideErrorLog