﻿;display routine


Procedure WC_REDRAW_MENU_ELEMENTS(_status.l)
  ;here we redraw the gadget window
  ;if window is resized or window is to small, or we use mousewheel
  Static _value.l=0 ;here we store the relativ value for our gadget list, so we can scroll it
  Define _posx.l=0, _posy.l=0
  
 Select _status.l
     
   Case  #GAD_DOWN
;      
;      If (_value.l+1)<ListSize(wc_menu_object())
;        _value.l+1
;      EndIf
     
     If SelectElement(wc_menu_object(),#LAST_UI_GADGET)
       If wc_menu_object()\_y<=0 
         _value.l+1
       EndIf
     EndIf
     

   Case  #GAD_UP
     
     If LastElement(wc_menu_object())
      If  wc_menu_object()\_y>0
        _value.l-1
      EndIf
      
    EndIf
    
       
 EndSelect
 
 
 _posy.l+_value.l
 
 ResetList(wc_menu_object())  ;THE OBJECT WINDOW
  
  While NextElement(wc_menu_object())
    
   If ListIndex(wc_menu_object())>=#LAST_UI_GADGET
   wc_menu_object()\_x=_posx.l*(wc_menu_image_size.l+1)
   wc_menu_object()\_y=_posy.l*(wc_menu_image_size.l+1)
   wc_menu_object()\_w=wc_menu_image_size.l
   ResizeGadget(ListIndex(wc_menu_object()),wc_menu_object()\_x,wc_menu_object()\_y,#PB_Ignore,#PB_Ignore)
     
EndIf
   
 _posx.l+1
  
  If _posx.l>3
    _posx.l=0
    _posy.l+1
  EndIf
  
  
  Wend
  
 
  
  EndProcedure



Procedure WC_DELETE_MAP_OBJECT()
  Define _find.l=0
  
  ResetList(map_object())
  
While NextElement(map_object())

    If map_object()\_full_screen=#False
  _find.l=SpriteCollision(wc_delpointer_gfx.l,WindowMouseX(v_window_parent_id),WindowMouseY(v_window_parent_id),map_object()\_gfx_id,map_object()\_x+wc_x_offset.l,map_object()\_y+wc_y_offset.l)
   EndIf

  If map_object()\_full_screen=#True
  _find.l=SpriteCollision(wc_delpointer_gfx.l,WindowMouseX(v_window_parent_id),WindowMouseY(v_window_parent_id),map_object()\_gfx_id,map_object()\_x,map_object()\_y)
   EndIf

  If _find.l And map_object()\_layer=wc_layer.b
    
    If IsSprite(map_object()\_gfx_id)
      
      DeleteElement(map_object())
       
    EndIf
    
  EndIf
  
Wend

  
EndProcedure




Procedure  WC_SHOW_ENGINE_AREA()  
  
  StartDrawing(WindowOutput(v_window_parent_id))
        DrawingMode(#PB_2DDrawing_Outlined)
        Box(1,1,wc_engine_screen_width.l,wc_engine_screen_height.l,RGB(200,200,200))
  StopDrawing()
  
EndProcedure




Procedure WC_SHOW_LAYER_INFO()
   
         StartDrawing(WindowOutput(v_window_parent_id))
         DrawingMode(#PB_2DDrawing_Outlined)
         DrawText(map_object()\_x+wc_x_offset.l,map_object()\_y+wc_y_offset.l,Str(map_object()\_object_auto_layer))
         StopDrawing()

       EndProcedure
       
       
       Procedure WC_CLEAR_SCREEN()
         ClearScreen(RGB(0,0,0))
         EndProcedure

Procedure WC_SHOW_TEMPLATE()
   If wc_template\is_valid=#True
  DisplayTransparentSprite(wc_template\id, wc_x_offset,wc_y_offset,wc_template\transparency)
  EndIf
EndProcedure


Procedure WC_SHOW_SCREEN_BUFFER()
  
;   If IsSprite(wc_screen_output\id)
;     FreeSprite(wc_screen_output\id)  ;free the memory  
;   EndIf
;   
;   wc_screen_output\id=GrabSprite(#PB_Any,0,0,v_window_w,v_window_h)
;   
;   
;   If IsSprite(wc_screen_output\id)
;     wc_screen_output\transparency=10
;     DisplayTransparentSprite(wc_screen_output\id,0,0,wc_screen_output\transparency)  
;   EndIf
;   

   FlipBuffers()
  EndProcedure


Procedure  WC_SHOW_MAIN_SCREEN()
  Define  _text.s=" WORKLAYER: "+Str(wc_layer.b)+"  SHOWLAYER: "+Str(wc_layer_show.b)+"  CHACHE ID: "+Str(v_cache_id.l)+"  CACHE USED: "+Str(v_cache_last_id.l)+"   FOVW: "+Str(wc_engine_screen_width.l)+"  FOVH: "+Str(wc_engine_screen_height.l)+" QUESTS: "+Str(wc_quest_book.l)+"   MAP:   "+GetFilePart(wc_global_load_save_path.s)+"       Code & Concept (C) Deutschmann Walter"
    
  ResetList(map_object())
  WC_CLEAR_SCREEN()
  WC_SHOW_TEMPLATE()  ;here we show teh template 
  ;----------- sort the tiles per layer
  
  SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))

  While NextElement(map_object())
    
    SpriteQuality(#PB_Sprite_BilinearFiltering)
    SpriteBlendingMode(#PB_Sprite_BlendSourceAlpha, #PB_Sprite_BlendInvertSourceAlpha) ;default
    
    If map_object()\_alpha_blend>0
      SpriteBlendingMode(#PB_Sprite_BlendSourceAlpha, map_object()\_alpha_blend)
    EndIf

      If wc_layer_show.b<>-127
        
        If wc_layer_show.b=map_object()\_layer
          DisplayTransparentSprite(map_object()\_gfx_id,map_object()\_x+wc_x_offset.l,map_object()\_y+wc_y_offset.l,map_object()\_transparency) 
        EndIf
      Else
        
        If map_object()\_full_screen=#False
          
          If map_object()\object_use_shadow=1
            ;16=for developement fixed value for shadow offset
            DisplayTransparentSprite(map_object()\_gfx_id,map_object()\_x+wc_x_offset.l+16,map_object()\_y+wc_y_offset.l+16,map_object()\object_shadow_intense,RGB(0,0,0))
          EndIf
          
          
          DisplayTransparentSprite(map_object()\_gfx_id,map_object()\_x+wc_x_offset.l,map_object()\_y+wc_y_offset.l,map_object()\_transparency)
        Else
          DisplayTransparentSprite(map_object()\_gfx_id,map_object()\_x,map_object()\_y,map_object()\_transparency)
        EndIf
 
      EndIf
      
      If wc_show_layer_id.b=#True
        WC_SHOW_LAYER_INFO()
      EndIf

  Wend
  
  ;the actual map tile which is attached to mouse pointer 
  If IsSprite(wc_work_gfx\_gfx_id)
    If wc_work_gfx\_alpha_blend<>0
  ;    SpriteBlendingMode(#PB_Sprite_BlendSourceAlpha, wc_work_gfx\_alpha_blend)
    EndIf
        DisplayTransparentSprite(wc_work_gfx\_gfx_id,WindowMouseX(v_window_parent_id)-SpriteWidth(wc_work_gfx\_gfx_id)/2,WindowMouseY(v_window_parent_id)-SpriteHeight(wc_work_gfx\_gfx_id)/2)  
  EndIf
  
  If IsSprite(wc_delpointer_gfx.l) 
    DisplayTransparentSprite(wc_delpointer_gfx.l,WindowMouseX(v_window_parent_id),WindowMouseY(v_window_parent_id))  
  EndIf
  ;---------------------------------------------------------------------------------------------------------------------------------------------------------
  
  ;show some informations like mouseposition and ammount of tiles used in the map. cache shows the undo/redo map saves.
    SetWindowTitle(v_window_parent_id,"MAP OBJECT ID: "+Str(ListSize(map_object()))+" MOUSEX: "+Str(WindowMouseX(v_window_parent_id)+wc_x_offset.l)+"  MOUSEY: "+Str(WindowMouseY(v_window_parent_id)+wc_y_offset.l)+_text.s+"   "+wc_auto_object.s)
    If wc_engine_screen_area_show.b=#True
    WC_SHOW_ENGINE_AREA()  
  EndIf
   WC_SHOW_SCREEN_BUFFER()
EndProcedure




; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 153
; FirstLine = 136
; Folding = --
; EnableXP
; EnableUser
; CPU = 1
; DisableDebugger